using System;
using System.Collections.Generic;
using System.Text;

namespace FF3LE
{
    public class ByteFlag
    {
        int data;
        string[] names;

        /// <summary>
        /// oCgf[^ɓĂ8bitFLAGf[^NX쐬
        /// </summary>
        /// <param name="data">8bit̃tONAME LSB珇bit0`7ŋLq</param>
        public ByteFlag(string[] data)
        {
            if(data.Length < 8)
            {
                names = new string[] {"G[","G[","G[","G[","G[","G[","G[","G["};
            }
            else
            {
                names= data;
            }
        }
        public ByteFlag()
        {

                names = new string[] { "G[", "G[", "G[", "G[", "G[", "G[", "G[", "G[" };

        }
        public ByteFlag(string data1,string data2,string data3,string data4,string data5,string data6,string data7,string data8)
        {
            names = new string[] { data1,data2,data3,data4,data5,data6,data7,data8 };
        }
        public ByteFlag(byte data,string data1, string data2, string data3, string data4, string data5, string data6, string data7, string data8)
        {
            this.data = data;
            names = new string[] { data1, data2, data3, data4, data5, data6, data7, data8 };
        }

        public byte GetData()
        {
            return (byte)data;
        }

        public void SetData(byte data)
        {
            this.data = data;
        }

        public bool this[string key]
        {
            set
            {
                for (int i = 0; i < 8; i++)
                {
                    if (names[i] == key)
                    {
                        if (value)
                        {
                            data |= (0x01 << i);
                        }
                        else
                        {
                            data &= ~(0x01 << i);
                        }
                        return;
                    }
                }
            }
            get
            {
                for (int i = 0; i < 8; i++)
                {
                    if (names[i] == key)
                    {
                        if ((data & (0x01 << i)) != 0)
                        {
                            return true;
                        }
                        else
                        {
                            return false;
                        }

                    }
                }

                return false;
            }
        }
        /// <summary>
        /// keyԋp
        /// </summary>
        /// <param name="key"></param>
        /// <returns></returns>
        public string this[int key]
        {
            get
            {
                if (key < 8 && key >= 0)
                {
                    return names[key];
                }
                else
                {
                    return "";
                }
            }
        }
    }
}
